/***************************************************************************
                          siggenerator.cpp  -  description
                             -------------------
    begin                : Sat Jul 20 2002
    copyright            : (C) 2002 by Scott Wheeler
    email                : wheeler@kde.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "siggenerator.h"

#include <qabstractitemmodel.h>
#include <qdatetime.h>

#include <krandom.h>

#include <settings.h>

SigGenerator::SigGenerator(QAbstractItemModel *model, int role)
    : m_model(model)
    , m_role(role)
    , header(Settings::header())
    , footer(Settings::footer())
{
}

SigGenerator::~SigGenerator()
{

}


QString SigGenerator::random() const
{
    const int count = m_model->rowCount();
    if(count <= 0)
	return(QString::null);	//krazy:exclude=nullstrassign for old broken gcc

    const int i = KRandom::random() % count;
    const QString text = m_model->index(i, 0).data(m_role).toString();
    
    return attachStandard(text);
}

QString SigGenerator::daily() const
{
    const int count = m_model->rowCount();
    if(count <= 0)
	return(QString::null);	//krazy:exclude=nullstrassign for old broken gcc

    QDate date;
    const int i = date.dayOfYear() % count;
    const QString text = m_model->index(i, 0).data(m_role).toString();
    return attachStandard(text);
}

QString SigGenerator::attachStandard(const QString &text) const
{
    QString s = text;

    if(!header.isEmpty())
	s = header + '\n' + s;
    if(!footer.isEmpty())
	s = s + '\n' + footer;

    return s;
}
